'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.receive = exports.del = exports.patch = exports.put = exports.post = exports.get = exports.DELETE = exports.PATCH = exports.PUT = exports.POST = exports.GET = exports.RECEIVE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _humps = require('humps');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RECEIVE = exports.RECEIVE = '@@redux-jsonapi/RECEIVE';
var GET = exports.GET = '@@redux-jsonapi/GET';
var POST = exports.POST = '@@redux-jsonapi/POST';
var PUT = exports.PUT = '@@redux-jsonapi/PUT';
var PATCH = exports.PATCH = '@@redux-jsonapi/PATCH';
var DELETE = exports.DELETE = '@@redux-jsonapi/DELETE';

var request = function request(method) {
  var payload = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var meta = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  return {
    type: method,
    payload: payload,
    meta: meta
  };
};

var get = exports.get = function get(resource, _ref) {
  var _ref$params = _ref.params;
  var params = _ref$params === undefined ? {} : _ref$params;
  var _ref$headers = _ref.headers;
  var headers = _ref$headers === undefined ? {} : _ref$headers;
  var _ref$meta = _ref.meta;
  var meta = _ref$meta === undefined ? {} : _ref$meta;

  return request(GET, { resource: resource, params: params, headers: headers }, meta);
};

var post = exports.post = function post(resource, _ref2) {
  var _ref2$params = _ref2.params;
  var params = _ref2$params === undefined ? {} : _ref2$params;
  var _ref2$headers = _ref2.headers;
  var headers = _ref2$headers === undefined ? {} : _ref2$headers;
  var _ref2$meta = _ref2.meta;
  var meta = _ref2$meta === undefined ? {} : _ref2$meta;

  return request(POST, { resource: resource, params: params, headers: headers }, meta);
};

var put = exports.put = function put(resource, _ref3) {
  var _ref3$params = _ref3.params;
  var params = _ref3$params === undefined ? {} : _ref3$params;
  var _ref3$headers = _ref3.headers;
  var headers = _ref3$headers === undefined ? {} : _ref3$headers;
  var _ref3$meta = _ref3.meta;
  var meta = _ref3$meta === undefined ? {} : _ref3$meta;

  return request(PUT, { resource: resource, params: params, headers: headers }, meta);
};

var patch = exports.patch = function patch(resource, _ref4) {
  var _ref4$params = _ref4.params;
  var params = _ref4$params === undefined ? {} : _ref4$params;
  var _ref4$headers = _ref4.headers;
  var headers = _ref4$headers === undefined ? {} : _ref4$headers;
  var _ref4$meta = _ref4.meta;
  var meta = _ref4$meta === undefined ? {} : _ref4$meta;

  return request(PATCH, { resource: resource, params: params, headers: headers }, meta);
};

var del = exports.del = function del(resource, _ref5) {
  var _ref5$params = _ref5.params;
  var params = _ref5$params === undefined ? {} : _ref5$params;
  var _ref5$headers = _ref5.headers;
  var headers = _ref5$headers === undefined ? {} : _ref5$headers;
  var _ref5$meta = _ref5.meta;
  var meta = _ref5$meta === undefined ? {} : _ref5$meta;

  return request(DELETE, { resource: resource, params: params, headers: headers }, meta);
};

var receive = exports.receive = function receive(resources) {
  return {
    type: RECEIVE,
    payload: {
      resources: resources
    }
  };
};

function getInitialState() {
  return {};
}

function receiveReducer(state, _ref6) {
  var resources = _ref6.resources;

  return resources.reduce(function (nextState, resource) {
    return _extends({}, nextState, _defineProperty({}, (0, _humps.camelize)(resource.type), _extends({}, nextState[(0, _humps.camelize)(resource.type)], _defineProperty({}, resource.id, resource))));
  }, state);
}

function reducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? getInitialState() : arguments[0];
  var _ref7 = arguments[1];
  var type = _ref7.type;
  var payload = _ref7.payload;

  switch (type) {
    case RECEIVE:
      return receiveReducer(state, payload);
    default:
      return state;
  }
}

exports.default = reducer;